#!/bin/sh
#------------------------------------------------------------------------------
# =========                 |
# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
#  \\    /   O peration     |
#   \\  /    A nd           | Copyright (C) 2011-2016 OpenFOAM Foundation
#    \\/     M anipulation  |
#-------------------------------------------------------------------------------
# License
#     This file is part of OpenFOAM.
#
#     OpenFOAM is free software: you can redistribute it and/or modify it
#     under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#     for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
#
# Script
#     wclean
#
# Usage
#     wclean [OPTION] [dir]
#     wclean [OPTION] target [dir [MakeDir]]
#
# Description
#     Clean up the wmake control directory Make/\$WM_OPTIONS and remove the
#     lnInclude directories generated for libraries.
#
#------------------------------------------------------------------------------
Script=${0##*/}

# Source the wmake functions
. ${0%/*}/scripts/wmakeFunctions

usage() {
    while [ "$#" -ge 1 ]; do echo "$1"; shift; done
    cat<<USAGE

Usage: $Script [OPTION] [dir]
       $Script [OPTION] target [dir [MakeDir]]

options:
  -s | -silent      Ignored - for compatibility with wmake
  -help             Print the usage

Clean up the wmake control directory Make/\$WM_OPTIONS and remove the
lnInclude directories generated for libraries.

The targets correspond to a subset of the 'wmake' special targets:
  all               All subdirectories, uses any Allwclean or Allclean
                    files if they exist
  exe | lib | libo | libso
                    Clean Make, any *.dep files and lnInclude directories
  empty             Remove empty sub-directories for the requested dir.
                    If executed in the main project directory, it will also
                    remove deprecated object directories and respective binaries
                    that refer to no-longer-existing source code.

USAGE
    exit 1
}


#------------------------------------------------------------------------------
# Parse arguments and options
#------------------------------------------------------------------------------

while [ "$#" -gt 0 ]
do
    case "$1" in
    -h | -help)
        usage
        ;;
    -s | -silent)    # Ignored - for compatibility with wmake
        shift
        ;;
    -*)
        usage "unknown option: '$*'"
        ;;
    *)
        break
        ;;
    esac
done


#------------------------------------------------------------------------------
# Check arguments and change to the directory in which to run wclean
#------------------------------------------------------------------------------

unset dir targetType
MakeDir=Make

if [ $# -ge 1 ]
then

    if [ -d "$1" ]
    then
        dir=$1
    else
        targetType=$1
    fi

    # Specified directory name:
    [ $# -ge 2 ] && dir=$2

    # Specified alternative name for the Make sub-directory:
    [ $# -ge 3 ] && MakeDir=$3

    if [ "$dir" ]
    then
        cd $dir 2>/dev/null || {
            echo "$Script error: could not change to directory '$dir'" 1>&2
            exit 1
        }
    fi

    # Provide some feedback
    echo "$Script ${dir:-./}"
fi


#------------------------------------------------------------------------------
# Remove empty sub-directories and exit
#------------------------------------------------------------------------------

if [ "$targetType" = empty ]
then
    # First pass: clean up empty source code directories

    echo "Searching for empty directories..."

    # Get sub-directories avoiding particular directories
    for dir in $(find . -mindepth 1 -maxdepth 1 \
                        -type d \( -name .git -prune -o -print \) )
    do
        echo "check dir: $dir"
        find $dir -depth -type d -empty -exec rmdir {} \; -print
    done

    echo "Search for empty directories complete."

    # Second pass: clean up object directories with WM_PROJECT_DIR that don't
    # have respective source code folders, along with the respective binaries

    expandPath $PWD
    if [ "$exPath" = "$WM_PROJECT_DIR" ]
    then
        findObjectDir $PWD

        if [ -d $objectsDir ]
        then
            echo "Searching for deprecated object directories at: $objectsDir"

            find $objectsDir -name 'variables' -print | \
            while read variablesFile
            do
                # Hack'ish way of getting the original source code path
                depFile=$(dirname $variablesFile)
                depToSource $depFile

                # Check if the original source code directory exists
                if [ ! -r "$sourceFile" ]
                then
                    # Delete the respective binary first
                    binaryFile=$(cat $variablesFile |
                                grep -e '^ *\(EXE\|LIB\) *= *' )

                    # Catch all file extension (o,a,so,?+) for libraries
                    if echo $binaryFile | grep -qe '^ *LIB *= *'
                    then
                        binaryFile="${binaryFile}.*"
                    fi

                    # Isolate path and translate environment variables
                    binaryFile=$(echo $binaryFile | \
                                 sed -e 's/^ *\(EXE\|LIB\) *= *//' \
                                     -e 's/(/{/g' -e 's/)/}/g' )

                    # Expand environment variables for path
                    binaryFile=$(eval echo $binaryFile)

                    # Verbosely remove binary file
                    if [ -n "$binaryFile" -a -e "$binaryFile" ]
                    then
                        rm -vf $binaryFile 2>/dev/null
                    fi

                    # Remove the deprecated object directory
                    rm -rvf $depFile 2>/dev/null
                fi
            done

            echo "Search for deprecated object directories complete."
        fi
    fi

    exit 0
fi


#------------------------------------------------------------------------------
# Recurse the directories tree
#------------------------------------------------------------------------------

if [ "$targetType" = all ]
then
    if [ -e Allwclean ]       # Consistent with Allwmake
    then
        ./Allwclean
        exit $?
    elif [ -e Allclean ]      # Often used for tutorial cases
    then
        ./Allclean
        exit $?
    else
        # For all the sub-directories containing a 'Make' directory
        for dir in `find . \( -type d -a -name Make \)`
        do
            dir=${dir%/Make} # Parent directory - trim /Make from the end
            echo $dir
            # If Allwclean exists execute otherwise wclean
            if [ -e "$dir/Allwclean" ]
            then
                $dir/Allwclean
            else
                $0 $dir
            fi
        done
    fi
fi

# targetType is not needed beyond this point
unset targetType


#------------------------------------------------------------------------------
# Clean the 'Make' directory if present
#------------------------------------------------------------------------------

if [ -d $MakeDir ]
then
    objectsDir=$MakeDir/$WM_OPTIONS
    if echo $PWD | grep "$WM_PROJECT_DIR"
    then
        platformPath=$WM_PROJECT_DIR/platforms/${WM_OPTIONS}
        objectsDir=$platformPath$(echo $PWD | sed s%$WM_PROJECT_DIR%% )
    fi
    rm -rf $objectsDir 2>/dev/null
fi


#------------------------------------------------------------------------------
# Remove the lnInclude directory if present
#------------------------------------------------------------------------------

if [ -d lnInclude ]
then
    rm -rf lnInclude 2>/dev/null
fi


#------------------------------------------------------------------------------
# Cleanup local variables and functions
#------------------------------------------------------------------------------

unset Script usage


#------------------------------------------------------------------------------
